routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\BuyController;
use App\Http\Controllers\AuthController;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\StoreController;
use App\Http\Controllers\WalletController;
use App\Http\Controllers\ProductController;
use App\Http\Controllers\VoucherController;
use App\Http\Controllers\NotificationController;

/*
|--------------------------------------------------------------------------
| Web Routesfunction () { return view('home'); });nam
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

//home
Route::get('/', [HomeController::class, 'home'])->name('home');

//Buy
Route::get('products/{product}/buy', [BuyController::class, 'buy'])->name('buy');
Route::post('products/{product}/buynow', [BuyController::class, 'buynow'])->name('buynow');

Route::group(['middleware' => 'auth'], function () {
    //Logout
    Route::get('logout', [AuthController::class, 'logout'])->name('logout');

    //Stores
    Route::resource('stores', StoreController::class);

    //Products
    Route::get('stores/{store}/products', [ProductController::class, 'index'])->name('products.index');
    Route::get('stores/{store}/products/create', [ProductController::class, 'create'])->name('products.create');
    Route::post('store/{store}/products/store', [ProductController::class, 'store'])->name('products.store');
    Route::get('stores/{store}/products/{product}/edit', [ProductController::class, 'edit'])->name('products.edit');
    Route::delete('store/{store}/products/{product}/delete', [ProductController::class, 'destroy'])->name('products.destroy');
    Route::get('stores/{store}/products/{product}/view', [ProductController::class, 'view'])->name('products.view');

    // Wallets
    Route::resource('wallets', WalletController::class)->only('show');

    // Voucher
    Route::get('stores/{store}/voucher', [VoucherController::class, 'index'])->name('vouchers.index');
    Route::get('stores/{store}/voucher/create', [VoucherController::class, 'create'])->name('vouchers.create');
    Route::post('store/{store}/voucher/store', [voucherController::class, 'store'])->name('vouchers.store');
    Route::delete('store/{store}/vouchers/{voucher}/delete', [VoucherController::class, 'destroy'])->name('vouchers.destroy');
    Route::get('stores/{store}/vouchers/{voucher}/edit', [VoucherController::class, 'edit'])->name('vouchers.edit');
    Route::post('store/{store}/vouchers/{voucher}/update', [VoucherController::class, 'update'])->name('vouchers.update');

    Route::resource('notifications', NotificationController::class)->only('index', 'destroy');
    Route::get("notifications/{notification}/read", [NotificationController::class, "read"])->name("notifications.read");
});


Route::group(['middleware' => 'guest'], function () {
    //Register & Login
    Route::get('register', [AuthController::class, 'register'])->name('register');
    Route::post('signup', [AuthController::class, 'signup'])->name('singup');
    Route::get('login', [AuthController::class, 'login'])->name('login');
    Route::post('signin', [AuthController::class, 'signin'])->name('signin');
});

app/Models/Product.php
<?php

namespace App\Models;

use App\Models\Image;
use App\Models\Review;
use App\Models\Category;
use Illuminate\Database\Eloquent\Model;
use App\Http\Controllers\ReviewController;
use Illuminate\Database\Eloquent\SoftDeletes;
use Illuminate\Database\Eloquent\Relations\HasMany;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Factories\HasFactory;

class Product extends Model
{
    use HasFactory;

    protected $fillable = [
        'name',
        'about',
        'price',
        'quantity',
        'category_id',
    ];

    protected $casts = [
        'price' => 'float',
        'quantity' => 'integer',
    ];

    public function store(): BelongsTo
    {
        return $this->belongsTo(Product::class);
    }

    public function images(): HasMany
    {
        return $this->hasMany(Image::class);
    }

    public function category(): BelongsTo
    {
        return $this->belongsTo(Category::class);
    }

    public function reviews()
    {
        return $this->morphMany(Review::class, 'reviewable');
    }
}

app/Http/Controllers/ProductController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\CreateProducteRequest;
use App\Http\Requests\UpdateProductRequest;
use App\Models\Store;
use App\Models\Product;
use App\Models\Category;
use App\Notifications\ProductQuantity;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class ProductController extends Controller
{
    // SRP - Single Responsibility Principle

    public function index(Store $store)
    {
        $user = Auth::user();
        $count = $user->notifications()->count();

        $products = $store->products()->simplePaginate();

        // if ($product->quantity < 5) {
            // $user->notify(new ProductQuantity($product->name));
        // }

        return view("products/index", [
            "products" => $products,
            "store" => $store,
            "count" => $count,
        ]);
    }

    public function create(Store $store)
    {
        $user = Auth::user();
        $count = $user->notifications()->count();

        $categories = Category::get();

        return view('products.create', [
            "store" => $store,
            "categories" => $categories,
            "count" => $count,
        ]);
    }

    public function store(CreateProducteRequest $request, Store $store)
    {
        $product = $store->products()->create($request->validated());

        $images = $this->uploadImages($request->validated('images'));

        $product->images()->createMany($images);

        return to_route('products.index', ['store' => $store]);
    }


    public function edit(Store $store, Product $product)
    {
        $user = Auth::user();
        $count = $user->notifications()->count();

        $categories = Category::get();

        $images = $product->images()->get();

        return view('products.edit', [
            "product" => $product,
            "store" => $store,
            "categories" => $categories,
            "images" => $images,
            "count" => $count,
        ]);
    }

    public function update(UpdateProductRequest $request, Store $store, Product $product)
    {

        $product->update($request->validated());

        if ($request->has('images')) {

            $product->images()->delete();

            $images = $this->uploadImages($request->validated('images'));

            $product->images()->createMany($images);
        }

        return to_route('products.index', ["store" => $store, "product" => $product]);
    }

    public function destroy(Store $store, Product $product)
    {
        $product->delete();

        return to_route('products.index', ["product" => $product, "store" => $store]);
    }

    public function view(Store $store, Product $product)
    {
        $user = Auth::user();
        $count = $user->notifications()->unread()->count();

        $images = $product->images()->get();

        return view("products.show", [
            "store" => $store,
            "product" => $product,
            "images" => $images,
            "count" => $count,
        ]);
    }
    private function uploadImages(array $images): array
    {
        $data = [];

        foreach ($images as $image) {
            $temp = [];
            $temp['path'] = $image->store('public');
            $data[] = $temp;
        }

        return $data;
    }
}

resources/views/products/create.blade.php
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Add Product</title>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/water.css@2/out/dark.css">
    <?php if (!$errors->isEmpty()) { ?>
        <ul>
            <?php foreach ($errors->messages() as $key => $messages) { ?>
                <?php foreach ($messages as $message) { ?>
                    <li style="color: red"><?= $message ?></li>
                <?php } ?>
            <?php } ?>
        </ul>
    <?php } ?>
</head>
<body>
    <h1>Add Product</h1>
    <a href="{{ route('logout') }}">Logout</a> |
    <a href="{{ route('stores.index') }}">All Stores</a> |
    <a href="{{ route('products.index', ['store' => $store->id])  }}">All Products</a> |
    <a href="{{ route('notifications.index')  }}">Notifacations</a> <span style="color: orange;">({{$count}})</span>
    <hr>
    <form action="{{ route('products.store', ['store' => $store->id]) }}" method="post" enctype="multipart/form-data">
        @csrf()

        <label for="name">Name</label>
        <input type="text" name="name" id="name">

        <select name="category_id" id="categories">
            <?php foreach ($categories as $category) {?>
                <option  value="<?php echo $category['id'];?>" ><?php echo $category['name'];?></option>
            <?php }?>
        </select>

        <label for="image">Add images</label>
        <input type="file" name="images[]" id="image" multiple>

        <label for="price">Price</label>
        <input type="integer" name="price" id="price">

        <label for="quantity">Quantity</label>
        <input type="integer" name="quantity" id="quantity">

        <label for="about">About</label>
        <textarea name="about" id="about" cols="30" rows="10"></textarea>

        <input type="submit" value="Create">
    </form>
</body>
</html>

resources/views/products/edit.blade.php
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Edit Product</title>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/water.css@2/out/dark.css">
    <?php if (!$errors->isEmpty()) { ?>
        <ul>
            <?php foreach ($errors->messages() as $key => $messages) { ?>
                <?php foreach ($messages as $message) { ?>
                    <li style="color: red"><?= $message ?></li>
                <?php } ?>
            <?php } ?>
        </ul>
    <?php } ?>
</head>
<body>
    <h1>Edit Product</h1>
    <a href="{{ route('logout') }}">Logout</a> |
    <a href="{{ route('stores.index') }}">All Stores</a> |
    <a href="{{ route('products.index', ['store' => $store->id])  }}">All Products</a> |
    <a href="{{ route('wallets.show', $wallet)  }}">Wallet</a> |
    <a href="{{ route('notifications.index')  }}">Notifacations</a> <span style="color: orange;">({{$count}})</span>
    <hr>
    <form action="{{ route('products.update', ['store' => $store->id, 'product' => $product->id]) }}" method="post" enctype="multipart/form-data">
        @csrf()

        <label for="name">Name</label>
        <input type="text" name="name" id="name" value="{{$product['name']}}">

        <label for="categoy">Category</label>
        <select name="category_id" id="categories">
            <?php foreach ($categories as $category) {?>
                <option  value="<?php echo $category['id'];?>" ><?php echo $category['name'];?></option>
            <?php }?>
        </select>

        <label for="image">Add images</label>
        @foreach ($images as $image)
            <img src="{{ Storage::url($image->path)}}" alt="Product image" width="256" style="display: block; margin: 10px 0;">
        @endforeach
        <input type="file" name="images[]" id="image" multiple>

        <label for="price">Price</label>
        <input type="integer" name="price" id="price" value="{{ $product['price'] }}">

        <label for="quantity">Quantity</label>
        <input type="integer" name="quantity" id="quantity" value="{{ $product['quantity'] }}">

        <label for="about">About</label>
        <textarea name="about" id="about" cols="30" rows="10" v>{{ $product['about'] }}</textarea>

        <input type="submit" value="Update">
    </form>
</body>
</html>

resources/views/products/index.blade.php
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/water.css@2/out/dark.css">
    <title>Products</title>
    <style>
        .delete-btn {padding: 0 !important;display: inline !important;background: transparent !important;color: var(--links) !important;}
        .delete-btn:hover {text-decoration: underline;}
        .delete-form {display: inline !important;vertical-align: middle !important;}
    </style>
</head>
<body>
    <h1>Products</h1>
    <a href="{{ route('stores.index') }}">Stores</a> |
    <a href="{{ route('products.create', ['store' => $store->id]) }}">Add product</a> |
    <a href="{{ route('wallets.show', $wallet)  }}">Wallet</a> |
    <a href="{{ route('vouchers.index', ['store' => $store->id])  }}">Vauchers</a> |
    <a href="{{ route('notifications.index')  }}">Notifacations</a> <span style="color: orange;">({{$count}})</span> |
    <a href="{{ route('logout') }}">Logout</a>
    <hr>
    <table>
        <tr>
            <th>Id</th>
            <th>Name</th>
            <th>price</th>
            <th>quantity</th>
            <th>Actions</th>
        </tr>
        @foreach($products as $product)
            <tr>
                <td>{{ $product->id }}</td>
                <td>{{ Str::limit($product->name) }}</td>
                <td>{{ $product->price }} $</td>
                <td>{{ $product->quantity }}</td>
                <td>
                    <a href="{{ route("products.edit", ["store" => $store, "product" => $product]) }}">Edit</a> |
                    <a href="{{ route("products.view", ["store" => $store, "product" => $product]) }}">View</a> |
                    <form onsubmit="return confirm('Are you sure?');" class="delete-form" action="{{route('products.destroy', ["store" => $store['id'],'product' => $product['id']]) }}" method="POST">
                        @method('DELETE')
                        @csrf()
                        <input class="delete-btn" type="submit" value="Delete">
                    </form>
                </td>
            </tr>

        @endforeach
    </table>

</body>
</html>

resources/views/products/show.blade.php
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/water.css@2/out/dark.css">
    <title>Show product</title>
</head>
<body>
    <h1>{{ $product->name }}</h1>
    <a href="{{ route('logout') }}">Logout</a> |
    <a href="{{ route('stores.index') }}">All Stores</a> |
    <a href="{{ route('products.index', ['store' => $store->id])  }}">All Products</a> |
    <a href="{{ route('wallets.show', $wallet)  }}">Wallet</a> |
    <a href="{{ route('notifications.index')  }}">Notifacations</a> <span style="color: orange;">({{$count}})</span>
    <hr>
    @foreach($images as $image)
    <img src="{{ Storage::url($image->path) }}" alt="Product image" width="256" style="margin: 3px;">
    @endforeach
    <h2>Price : {{ $product->price }}</h2>
    <h2>Ctegory : {{ $product->category->name }}</h2>
    @if($product->quantity <= 5 )
        <p style="color : orange">Only {{ $product->quantity }} left in store </p>
    @endif
    <h2>About : </h2>
    <p>{{ $product->about }}</p>
</body>
</html>